#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts_morph_1 = require("ts-morph");
var command_line_args_1 = __importDefault(require("command-line-args"));
var command_line_usage_1 = __importDefault(require("command-line-usage"));
var TsConfig = __importStar(require("tsconfig"));
var index_1 = require("./index");
var optionList = [
    {
        description: 'A JavaScript condition used to automatically return `true` from guard functions, bypassing checks. eg. `process.env.DEBUG === "production"`.',
        name: 'shortcircuit',
        type: String,
        typeLabel: '{underline javascript}',
    },
    {
        defaultOption: true,
        description: 'File(s) to generate guard for. If excluded this will process {italic all} project files.',
        multiple: true,
        name: 'paths',
        type: String,
        typeLabel: '{underline file[]} ...',
    },
    {
        description: 'Generate checks for all exported types, even those not marked with comment',
        name: 'export-all',
        type: Boolean,
    },
    {
        description: 'Adds TypeGuard import to source file, to also export TypeGuard from source use with --import-guards. Optionally accepts a string to choose custom import alias.',
        name: 'import-guards',
        typeLabel: '{underline TypeGuard}',
        type: String,
    },
    {
        description: 'Allows customisation of the filename for the generated guards file',
        name: 'guard-file-name',
        type: String,
        typeLabel: '{underline extension}',
    },
    {
        description: 'Overrides the default behavior for --import-guards by skipping export from source.',
        name: 'prevent-export-imported',
        type: Boolean,
    },
    {
        description: 'Path to `tsconfig.json`.',
        name: 'project',
        type: String,
        typeLabel: '{underline file}',
    },
    {
        alias: 'h',
        description: 'Print this usage guide.',
        name: 'help',
        type: Boolean,
    },
    {
        alias: 'd',
        description: 'Include debug logs in generated type guards.',
        name: 'debug',
        type: Boolean,
    },
];
var options = __assign({ paths: [], help: false }, command_line_args_1.default(optionList));
function run() {
    return __awaiter(this, void 0, void 0, function () {
        var project, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, TsConfig.resolve(process.cwd(), options.project)];
                case 1:
                    project = _a.sent();
                    if (project === undefined) {
                        console.error('Could not find tsconfig');
                        return [2 /*return*/];
                    }
                    if ('import-guards' in options) {
                        /** Checks if valid name passed as argument or replace with default if empty */
                        if (!options['import-guards']) {
                            options['import-guards'] = 'TypeGuards';
                        }
                        try {
                            eval("const " + options['import-guards'] + " = true");
                        }
                        catch (error) {
                            console.log('Please pass a valid import alias');
                            throw error;
                        }
                    }
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, index_1.generate({
                            paths: options.paths,
                            processOptions: {
                                debug: options.debug,
                                exportAll: options['export-all'],
                                importGuards: options['import-guards'],
                                preventExportImported: options['prevent-export-imported'],
                                shortCircuitCondition: options.shortcircuit,
                                guardFileName: options['guard-file-name'],
                            },
                            project: project,
                        })];
                case 3:
                    _a.sent();
                    console.log('Done!');
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    if (error_1 instanceof ts_morph_1.FileNotFoundError) {
                        console.error(error_1.message);
                    }
                    else {
                        throw error_1;
                    }
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
}
if (options.help) {
    // eslint-disable-next-line @typescript-eslint/no-var-requires
    var _a = require('../package.json'), name = _a.name, version = _a.version, description = _a.description;
    console.log(command_line_usage_1.default([
        {
            header: name + " " + version,
            content: description,
        },
        {
            header: 'Options',
            optionList: optionList,
        },
    ]));
}
else {
    run();
}
//# sourceMappingURL=cli.js.map